#include <iostream>
#include<string>
#include<cmath>
using namespace std;

int main()
{
    string T,rec;
    int duzina,i,j,b1=0,b2=0,l=0,k=0,minduz;
    cin>>T;
    duzina=T.length();
    bool palindrom=true;
    for(i=0; i<duzina/2; i++)
    {
        if(T[i]!=T[duzina-i-1])
        {
            palindrom=false;
        }
    }
    string r[duzina];
    string m;
    m=T;
    string s[100];
    for(i=0; i<duzina; i++)
    {
        r[i]=T[i];
    }
    for(i=0; i<duzina/2; i++)
    {
         if(r[i]!=r[duzina-i-1])
        {
            j=duzina-i-1;
            do
            {
                j--;
                if(r[i]==r[j])
            {
                s[0]=r[duzina-i-1];
                r[duzina-i-1]=r[j];
                r[j]=s[0];
            }
            }
            while(r[i]!=r[j] && r[i]==r[j]);
        }
    }
    for(i=0; i<duzina; i++)
    {
        rec=r[i]+rec;
    }
    for(i=0; i<duzina; i++)
    {
        if(rec[i]!=m[i])
        {
            l=i;
        }
        if(rec[i]!=m[i] && i!=l)
        {
            k=i;
        }
    }
    minduz=k-l;
    if(palindrom==true)
    {cout<<1;}
    else 
    {
        cout<<abs(minduz+1);
    }
    return 0;
}